-- This mod requires Mobs Redo.

-- ===================================================================

local modname = minetest.get_current_modname()
local modpath = minetest.get_modpath (modname)
local aoc     = tonumber (minetest.setting_get ("sealife_aoc")) or 8

-- ===================================================================

local sealife_disable_jellyfish      =
      minetest.setting_getbool ("sealife_disable_jellyfish"      )
local sealife_disable_mobs           =
      minetest.setting_getbool ("sealife_disable_mobs"           )
local sealife_disable_monsters       =
      minetest.setting_getbool ("sealife_disable_monsters"       )
local sealife_peaceful               =
      minetest.setting_getbool ("sealife_peaceful"               )

local monsttype = "animal"
if    sealife_peaceful then
      monsttype = "animal"
end

local mobname
local xyz

-- ===================================================================

local function getnumsetting (name)
    local  n = tonumber (minetest.setting_get (name)) or 0
    return n
end

-- ===================================================================

local chance    =   4000
    xyz = getnumsetting ("sealife_jellyfish_chance")
if  xyz ~= 0 then
      chance    = xyz
end

local minheight = -31000
    xyz = getnumsetting ("sealife_jellyfish_minheight")
if  xyz == 0 then
    xyz = getnumsetting ("sealife_minheight")
end
if  xyz ~= 0 then
      minheight = xyz
end

local maxheight =     -1
    xyz = getnumsetting ("sealife_jellyfish_maxheight")
if  xyz == 0 then
    xyz = getnumsetting ("sealife_maxheight")
end
if  xyz ~= 0 then
      maxheight = xyz
end

-- ===================================================================

mobname = modname .. ":jellyfish"

mobs:register_mob (mobname, {
    type = "animal",
    attack_type = "dogfight",
    damage = 5,
    hp_min = 5,
    hp_max = 10,
    armor = 100,
    collisionbox = {-0.25, -0.25, -0.25, 0.25, 0.25, 0.25},
    visual = "mesh",
    mesh = "jellyfish.b3d",
    textures = {
        {"jellyfish.png"}
    },
    makes_footstep_sound = false,
    walk_velocity = 0.1,
    run_velocity = 0.1,
    fly = true,
    fly_in = "default:water_source",
    fall_speed = 0,
    view_range = 10,
    water_damage = 0,
    lava_damage = 5,
    light_damage = 0,

    on_rightclick = function (self, clicker)
        mobs:capture_mob (self, clicker, 80, 100, 0, true, nil)
    end
})

if not sealife_disable_jellyfish and
   not sealife_disable_mobs      then
mobs:spawn_specific (mobname,
{
    "default:water_source"        ,
    "default:river_water_source"  ,
} ,
{
    "default:water_flowing"       ,
    "default:water_source"        ,
    "default:river_water_flowing" ,
    "default:river_water_source"  ,
} ,
2, 25, 30, chance, aoc, minheight, maxheight)
end

mobs:register_egg (mobname,
"Jellyfish", "jellyfish_inv.png", 0)
