-- This mod requires Mobs Redo.

-- ===================================================================

local modname = minetest.get_current_modname()
local modpath = minetest.get_modpath (modname)
local aoc     = tonumber (minetest.setting_get ("sealife_aoc")) or 8

-- ===================================================================

local sealife_disable_turtles        =
      minetest.setting_getbool ("sealife_disable_turtles"        )
local sealife_disable_mobs           =
      minetest.setting_getbool ("sealife_disable_mobs"           )
local sealife_disable_monsters       =
      minetest.setting_getbool ("sealife_disable_monsters"       )
local sealife_peaceful               =
      minetest.setting_getbool ("sealife_peaceful"               )

local monsttype = "animal"
if    sealife_peaceful then
      monsttype = "animal"
end

local mobname
local xyz

-- ===================================================================

local function getnumsetting (name)
    local  n = tonumber (minetest.setting_get (name)) or 0
    return n
end

-- ===================================================================

local chance    =  24000
    xyz = getnumsetting ("sealife_turtles_chance")
if  xyz ~= 0 then
      chance    = xyz
end

local minheight = -31000
    xyz = getnumsetting ("sealife_turtles_minheight")
if  xyz == 0 then
    xyz = getnumsetting ("sealife_minheight")
end
if  xyz ~= 0 then
      minheight = xyz
end

local maxheight =     -1
    xyz = getnumsetting ("sealife_turtles_maxheight")
if  xyz == 0 then
    xyz = getnumsetting ("sealife_maxheight")
end
if  xyz ~= 0 then
      maxheight = xyz
end

-- ===================================================================

local l_colors = {
    "#604000:175",  --brown
    "#604000:100",  --brown2
    "#ffffff:150",  --white
    "#404040:150",  --dark_grey
    "#a0a0a0:150",  --grey
    "#808000:150",  --olive
    "#ff0000:150"   --red
}

local l_skins = {
    {"turtle1.png^turtle2.png^turtle3.png^turtle4.png^turtle5.png^turtle6.png^turtle7.png"},
    {"turtle1.png^(turtle2.png^[colorize:"..l_colors[5]..")^(turtle3.png^[colorize:"..l_colors[4]..")^(turtle4.png^[colorize:"..l_colors[1]..")^(turtle5.png^[colorize:"..l_colors[2]..")^(turtle6.png^[colorize:"..l_colors[6]..")^turtle7.png"}
}

local l_anims = {
    speed_normal = 24,  speed_run = 24,
    stand_start = 1,    stand_end = 50,
    walk_start = 60,    walk_end = 90,
    run_start = 60,     run_end = 90,
    hide_start = 95,    hide_end = 100
}

local l_model = "mobf_turtle.x"

-- ===================================================================

mobname = modname .. ":seaturtle"

mobs:register_mob (mobname, {
    type = "animal",
    type = "animal",
    passive = true,
    hp_min = 20,
    hp_max = 30,
    armor = 250,
    collisionbox = {-0.8, 0.0, -0.8, 0.8, 0.7, 0.8},
    visual = "mesh",
    visual_size = {x=2,y=2},
    mesh = l_model,
    textures = l_skins,
    makes_footstep_sound = false,
    view_range = 10,
    rotate = 270,
    walk_velocity = 1,
    run_velocity = 1.5,
    stepheight = 1,
    jump = false,
    fly = true,
    fly_in = "default:water_source",
    fall_speed = 0,
    floats = 1,
    water_damage = 0,
    lava_damage = 5,
    light_damage = 0,
    fall_damage = 0,
    animation = l_anims,

    on_rightclick = function (self, clicker)
        mobs:capture_mob (self, clicker, 0, 0, 80, true, nil)
    end
})

if not sealife_disable_turtles and
   not sealife_disable_mobs    then
mobs:spawn_specific (mobname,
{
    "default:water_flowing"       ,
    "default:water_source"        ,
    "default:river_water_flowing" ,
    "default:river_water_source"  ,
} ,
{
    "default:water_flowing"       ,
    "default:water_source"        ,
    "default:river_water_flowing" ,
    "default:river_water_source"  ,
    "group:seaplants"             ,
    "seawrecks:woodship"          ,
    "seawrecks:uboot"             ,
} ,
3, 20, 30, chance, aoc, minheight, maxheight)
end

mobs:register_egg (mobname, "Sea Turtle", "default_water.png", 1)
